-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THMain = {}
local THMain_mt = Class(THMain, THCore)
function THMain:new(dataKey, mt)
mt = Utils.getNoNil(mt, THMain_mt)
local newEnv = THCore:new(dataKey, mt)
return newEnv
end
function THMain:initializeSettings()
if THMain:superClass().initializeSettings(self) then
if self:addSettingCategory("constructionScreen") then
if self:addSetting("constructionScreenZoom", nil,nil, "constructionScreen") then
for i = 100, 500, 25 do
local zoomFactor = g_thUtils:round(i / 100, 2)
local zoomText = string.format("%d%%", i)
self:addSettingValue("constructionScreenZoom", zoomFactor, zoomText)
end
end
end
return true
end
return false
end
THBaseMission = {}
function THBaseMission:hook_loadMapFinished(superFunc, ...)
local function appendFunc(...)
local protectedChunk = function()
if not self.cancelLoading then
if g_thMain:initializeSettings() then
g_thMain:loadSettings()
end
end
end
g_thMain:call(protectedChunk)
return ...
end
return appendFunc(superFunc(self, ...))
end
g_thMain = THMain:new("thCameraSettings")
if g_thMain ~= nil then
local function runScript()
local modPath = g_thMain.modPath
g_thMain:initializeLoadedMods()
g_thMain:setProtectedHook("BaseMission", "loadMapFinished", THBaseMission)
source(modPath.."scripts/gui/InGameMenuGeneralSettingsFrame.lua")
source(modPath.."scripts/gui/ConstructionScreen.lua")
end
g_thMain:call(runScript)
end