-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THConstructionScreen = {}
function THConstructionScreen:initialize()
local globalEnv = g_thUtils:getGlobalEnv()
self.baseCameraDistanceRangeZ = globalEnv.GuiTopDownCamera.DISTANCE_RANGE_Z
self.baseCursorRaycastDistance = globalEnv.GuiTopDownCursor.RAYCAST_DISTANCE
return true
end
function THConstructionScreen:hook_update(superFunc, dt, ...)
local envData = g_thMain:call("getDataTable", self, true, THConstructionScreen)
local camera, cameraUpdatePositionFunc, oldCameraUpdatePositionFunc = nil,nil,nil
local cursor, cursorUpdateRaycastFunc, oldCursorUpdateRaycastFunc = nil,nil,nil
local function prependFunc()
local globalEnv = g_thUtils:getGlobalEnv()
local cameraZoomFactor = g_thMain:getSettingValue("constructionScreenZoom")
local function hook_cameraUpdatePosition(pSuperFunc, pSelf, ...)
local vGuiTopDownCamera = nil
local function vPrependFunc()
vGuiTopDownCamera = globalEnv.GuiTopDownCamera
vGuiTopDownCamera.DISTANCE_RANGE_Z = envData.baseCameraDistanceRangeZ * cameraZoomFactor
end
local function vAppendFunc(...)
if vGuiTopDownCamera ~= nil then vGuiTopDownCamera.DISTANCE_RANGE_Z = envData.baseCameraDistanceRangeZ end
return ...
end
g_thMain:call(vPrependFunc)
return vAppendFunc(pSuperFunc(pSelf, ...))
end
local function hook_cursorUpdateRaycast(pSuperFunc, pSelf, ...)
local vGuiTopDownCursor = nil
local function vPrependFunc()
vGuiTopDownCursor = globalEnv.GuiTopDownCursor
vGuiTopDownCursor.RAYCAST_DISTANCE = envData.baseCursorRaycastDistance * cameraZoomFactor
end
local function vAppendFunc(...)
if vGuiTopDownCursor ~= nil then vGuiTopDownCursor.RAYCAST_DISTANCE = envData.baseCursorRaycastDistance end
return ...
end
g_thMain:call(vPrependFunc)
return vAppendFunc(pSuperFunc(pSelf, ...))
end
camera, cameraUpdatePositionFunc, oldCameraUpdatePositionFunc = g_thUtils:hookFunction(self.camera, "updatePosition", hook_cameraUpdatePosition)
cursor, cursorUpdateRaycastFunc, oldCursorUpdateRaycastFunc = g_thUtils:hookFunction(self.cursor, "updateRaycast", hook_cursorUpdateRaycast)
end
local function appendFunc(...)
if cameraUpdatePositionFunc ~= nil then rawset(camera, "updatePosition", oldCameraUpdatePositionFunc) end
if cursorUpdateRaycastFunc ~= nil then rawset(cursor, "updateRaycast", oldCursorUpdateRaycastFunc) end
return ...
end
g_thMain:call(prependFunc)
return appendFunc(superFunc(self, dt, ...))
end
local function runScript()
g_thMain:setProtectedHook("ConstructionScreen", "update", THConstructionScreen)
end
g_thMain:call(runScript)